%define name	gpac
%define version	0.4.5
%define rel	2
%define release %mkrel %{rel}
%define osmo	Osmo4

# disable format string check, can't fix it for WxWidgets part
%define Werror_cflags %{nil}

# looks like no stable ABI => version is %major
%define major	%version
%define libname	%mklibname %name %major
%define modname %mklibname %name-modules
%define devname	%mklibname %name -d

Name: 	 	%{name}
Summary: 	MPEG-4 multimedia framework
Version: 	%{version}
Release: 	%{release}

Source:		http://downloads.sourceforge.net/gpac/gpac-%{version}.tar.gz
# (Anssi 05/2011) Fix soname libgpac.so => libgpac-VERSION.so
Patch0:		gpac-soname.patch
URL:		http://gpac.sourceforge.net/
License:	LGPLv2+
Group:		Video
BuildRequires:	ImageMagick
BuildRequires:	SDL-devel
BuildRequires:	mesaglu-devel
BuildRequires:	mesaglut-devel
BuildRequires:	freetype2-devel
BuildRequires:	libfaad2-devel
BuildRequires:	jpeg-devel
BuildRequires:	png-devel
BuildRequires:	libmad-devel
BuildRequires:	xvid-devel
BuildRequires:	ffmpeg-devel
BuildRequires:	libxml2-devel
BuildRequires:	openssl-devel
BuildRequires:	zlib-devel
BuildRequires:	libogg-devel libvorbis-devel libtheora-devel
BuildRequires:	wxGTK-devel
BuildRequires:	xulrunner-devel
BuildRequires:	libalsa-devel
BuildRequires:	pulseaudio-devel
BuildRequires:	libxv-devel
# (Anssi 05/2011) Otherwise partially builds against older version of itself:
BuildConflicts:	gpac-devel
BuildConflicts:	gpac < 0.4.5-2 
Requires:	%modname >= %{version}-%{release}

%description
GPAC is a multimedia framework based on the MPEG-4 Systems standard developed
from scratch in ANSI C.  The original development goal is to provide a clean
(a.k.a. readable by as many people as possible), small and flexible
alternative to the MPEG-4 Systems reference software.

The natural evolution has been the integration of recent multimedia standards
(SVG/SMIL, VRML, X3D, SWF, 3GPP(2) tools, etc) into a single framework.
VRML97 and a good amount of the X3D standard have already been integrated
into GPAC, as well as some SVG support and experimental Macromedia Flash
support.

The current GPAC release (0.4.0) already covers a very large part of the
MPEG-4 standard, and has some good support for 3GPP and VRML/X3D, and
features what can probably be seen as the most advanced and robust 2D MPEG-4
Player available worldwide, as well as a decent 3D player.

GPAC also features MPEG-4 Systems encoders/multiplexers, publishing tools for
content distribution for MP4 and 3GPP(2) files and many tools for scene
descriptions (MPEG4<->VRML<->X3D converters, SWF->MPEG-4, etc...).

This package is in tainted repository because it incorporates MPEG-4 technology, covered by
software patents.

%package -n %modname
Summary:	GPAC framework modules
Group:		System/Libraries

%description -n %modname
GPAC is a multimedia framework based on the MPEG-4 Systems standard developed
from scratch in ANSI C.

This package contains the GPAC modules.

This package is in tainted repository because it incorporates MPEG-4
technology which may be covered by software patents.


%package -n %libname
Summary:	GPAC shared library
Group:		System/Libraries

%description -n %libname
GPAC is a multimedia framework based on the MPEG-4 Systems standard developed
from scratch in ANSI C.

This package provides the GPAC shared library.

This package is in tainted repository because it incorporates MPEG-4
technology which may be covered by software patents.

%package -n	%devname
Summary:	Development headers and library for gpac
Group:		Development/C
Obsoletes:	gpac-devel < 0.4.5-3
Requires:	%libname = %version
Provides:	gpac-devel = %{version}-%{release}

%description -n	%devname
Development headers and libraries for gpac.

This package is in tainted repository because it incorporates MPEG-4
technology which may be covered by software patents.

%package -n	osmo4
Summary:	Media player based on gpac
Group:		Video
Requires:       %modname >= %{version}-%{release}
Obsoletes:	Osmo4 < 0.4.5-3
Provides:	Osmo4 = %{version}-%{release}

%description -n osmo4
Osmo4 is an MPEG-4 player with the following features:
  * MPEG-4 Systems player:
  * Optimized 2D graphics renderer compliant with the Complete2D Scene Graph
    and Graphics profiles.
  * Video and audio presentation achieved through plugins
  * Multimedia player features:
    * Timeline controls: play, pause, step.
    * Graphics features: antialising, zoom and pan, scalable resizing of
      rendering area, basic full screen support.
    * Support for Advanced Text and Graphics extension of MPEG-4 Systems
      under standardization.
    * Frame export to JPG, PNG, BMP.

Osmo4 enables the use of MPEG-4 Systems in a vast aplication domain, among
which:
  * downloaded or streamed cartoons
  * synchronized, interactive mixes of graphics, text, video and audio
  * applications benefiting from MPEG-7 and MPEG-21 advances: meta-data,
    encryption, watermarking, rights management

This package is in tainted repository because it incorporates MPEG-4 technology, covered by
software patents.

%prep
%setup -q -n gpac
%apply_patches
chmod 755 configure
# lib64 compatible
perl -p -i -e 's/lGLU/lGLU\ \-L\/usr\/X11R6\/%{_lib}/g' configure
perl -p -i -e 's,\$prefix/lib/gpac,\$prefix/%{_lib}/gpac,' configure
perl -p -i -e 's,\$\(prefix\)/lib,\$(prefix)/%{_lib},' Makefile

# SHH!
perl -p -i -e 's/Wall/w/g' `find -name Makefile`

%build
./configure --prefix=%buildroot/%{_prefix} \
	--use-js=no

# parallel make fails
make OPTFLAGS="%optflags -fPIC" CPPFLAGS="%optflags -fPIC" GECKO_PATH="%(pkg-config --variable=includedir libxul)"

%install
rm -rf %buildroot
make mandir=%buildroot/usr/share/man install
make install-lib

# menu
mkdir -p %buildroot%{_datadir}/applications
cat << EOF > %buildroot%{_datadir}/applications/%{_real_vendor}-%{osmo}.desktop
[Desktop Entry]
Name=%{osmo}
Comment=MPEG-4 Media Player
Exec=%{osmo}
Icon=%{osmo}
Terminal=false
Type=Application
Categories=AudioVideo;Video;
EOF

#icons
mkdir -p %buildroot/%_liconsdir
convert -size 48x48 applications/osmo4_wx/osmo4.xpm %buildroot/%_liconsdir/%osmo.png
mkdir -p %buildroot/%_iconsdir
convert -size 32x32 applications/osmo4_wx/osmo4.xpm %buildroot/%_iconsdir/%osmo.png
mkdir -p %buildroot/%_miconsdir
convert -size 16x16 applications/osmo4_wx/osmo4.xpm %buildroot/%_miconsdir/%osmo.png

%clean
rm -rf %buildroot

%files
%defattr(-,root,root)
%doc AUTHORS BUGS Changelog COPYING README TODO
%{_bindir}/MP4*
%{_libdir}/*.so
%{_libdir}/%name
%{_mandir}/man1/*
%{_datadir}/%{name}

%files -n %libname
%defattr(-,root,root)
%{_libdir}/libgpac-%{version}.so

%files -n %modname
%defattr(-,root,root)
%{_libdir}/%{name}

%files -n osmo4
%defattr(-,root,root)
%{_bindir}/Osmo4
%{_datadir}/applications/%{_real_vendor}-%{osmo}.desktop
%{_liconsdir}/%osmo.png
%{_iconsdir}/%osmo.png
%{_miconsdir}/%osmo.png

%files -n %devname
%defattr(-,root,root)
%{_includedir}/%name
%{_libdir}/libgpac.so
%{_libdir}/*.a


%changelog
* Sun May 08 2011 anssi <anssi> 0.4.5-2.mga1
+ Revision: 96550
- fix library packaging according to policy
- fix license tag

  + mikala <mikala>
    - Add a xdg menu for Osmo4 player
    - use %%buildroot
    - Remove plf reference
    - clean spec
    - imported package gpac


* Sat Apr 11 2009 Anssi Hannula <anssi@zarb.org> 0.4.5-1plf2009.1
- new version (from bug #174)
- add more buildrequires

* Mon Apr 14 2008 Anssi Hannula <anssi@zarb.org> 0.4.4-0.rc2.1plf2008.1
- new version

* Sat Oct 21 2006 Anssi Hannula <anssi@zarb.org> 0.4.3-0.20061021.1plf2007.0
- new snapshot
- fix buildrequires for backportability
- buildrequire wxGTK2.6-devel explicitely, build with 2.7 fails
- standardize PLF reason

* Fri Sep 01 2006 Anssi Hannula <anssi@zarb.org> 0.4.1-0.20060630.2plf2007.0
- lib64 fixes

* Fri Jan 30 2006 Austin Acton <austin@mandriva.org> 0.4.1-0.20060630.1plf2007.0
- initial package
